%{
open Fscw_tree
%}

%token<string> CopyChar
%token<string * int> SepCPrologue
%token<string * int> SepFSCPrologue
%token<string * int> SepRequiredDecls
%token<string * int> SepNativeImplementation
%token STRUCT TYPEDEF REQUIRE_FUNCTION AUTO_GENERATE EMIT_TYPEINFO
%token SEMICOLON LPAREN RPAREN
%token<string> IDENTIFIER
%token Eof

%start parse_fscw
%type<Fscw_tree.t> parse_fscw

%%

parse_fscw:
  chars
  SepCPrologue
  chars
  SepFSCPrologue
  chars
  SepRequiredDecls
  required_decls
  SepNativeImplementation
  chars
  Eof
  { { r_prologue = $1 ^ "\n", (!filename, 1);
      r_c_prologue = $3 ^ "\n", $2;
      r_fsc_prologue = $5 ^ "\n", $4;
      r_required_decls = $7, $6;
      r_native_implementation = $9, $8; } }

chars:
  /* empty */ { "" }
| chars CopyChar { $1 ^ $2 }

required_decls:
  /* empty */ { [] }
| required_decls required_decl { $1 @ [$2] }

required_decl:
  TYPEDEF IDENTIFIER SEMICOLON { RequireTypedef $2 }
| STRUCT IDENTIFIER SEMICOLON { RequireStruct $2 }
| REQUIRE_FUNCTION IDENTIFIER SEMICOLON { RequireFunction $2 }
| AUTO_GENERATE IDENTIFIER SEMICOLON { AutoGenerate $2 }
| EMIT_TYPEINFO IDENTIFIER SEMICOLON { EmitTypeinfo $2 }

%%
