(* 
   Part of Fail-Safe C Compiler. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2008 AIST.

   This file is written by Yutaka Oiwa in 2008. *)

(** Printers for CTT types. *)

val encode_c_string : string -> string
val strof_builtin_type : Ctt_abstree.builtin_type -> string
val strof_c_type_qualifiers : Ctt_abstree.c_type -> string
val strof_c_type :
  ?name:string -> ?argnames:string list -> Ctt_abstree.c_type -> string
val strof_union_flag : Ctt_abstree.union_flag -> string
val strof_binop : Cttm_abstree.binop -> string
val strof_unaryop : Cttm_abstree.unaryop -> string
val strof_ctt_constant : Cttm_abstree.c_constants -> string
val strof_local_storage_class : Ctt_abstree.local_storage_class -> string
val strof_global_storage_class : Ctt_abstree.global_storage_class -> string
val strof_expr_desc : ?show_type:bool -> Ctt_abstree.texpr -> string
val strof_expr : ?show_type:bool -> Ctt_abstree.expr -> string
val strof_ctt_initalizer : Ctt_abstree.ctt_initializer -> string
val strof_local_variable_declaration :
  Ctt_abstree.local_storage_class * Ctt_abstree.c_type * string *
  Ctt_abstree.ctt_initializer option -> string
val strof_statement : Ctt_abstree.statement -> string
val strof_global_declaration : Ctt_abstree.global_declaration_desc -> string
val strof_mexpr_desc : ?show_type:bool -> Cttm_abstree.mexpr -> string
val strof_mexpr : ?show_type:bool -> Cttm_abstree.mexpr -> string
val strof_cttm_lv : ?show_type:bool -> Cttm_abstree.mem_object -> string
val strof_fields_suffix :
  ?show_type:bool -> Cttm_abstree.field list -> string
val strof_cttm_initalizer : Cttm_abstree.cttm_initializer -> string
