(* 
   Part of Fail-Safe C Compiler. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-     AIST.

   This file is written by Yutaka Oiwa in 2006. *)

(* generic type for location-attributed terms *)

type location = string * int * int * bool
let dummy_location = ("", 0, 0, false)

type 'a t = 
    { locterm_v : 'a;
      locterm_loc : location }

let locput ~loc v = { locterm_v = v; locterm_loc = loc }
let locput_dummy v = locput ~loc:dummy_location v

let locval v = v.locterm_v
let locget v = v.locterm_loc

let loccopy ~orig v = locput ~loc:(locget orig) v

let locmap f v = 
  loccopy ~orig:v (f ~loc:(locget v) v.locterm_v)

let locmap_list f l = 
  Util.list_map (locmap f) l

(*let locmap_list_glist f l = 
  List.iter
    (fun v -> f ~add:(fun l a -> Glist.put l (loccopy ~orig:v a)))
    l*)

let locmap_flatten f l = 
  Util.map_flatten
    (fun lv ->
      Util.list_map 
	(fun v' -> loccopy ~orig:lv v')
	(f ~loc:lv.locterm_loc lv.locterm_v))
    l

