/* 
   Part of Fail-Safe C Runtime. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2006 AIST.
   (c) 2006	 Lepidum Co. Ltd.

   This file is written by Lepidum Co. Ltd. in 2006.

   This file is distributed under Apache License 2.0 with a special exception.
   See the file LICENSE contained in the distribution.
*/
/**
 * @file stdlib/chmod.c
 */
#define FSC_RUNTIME_LIBRARY
#include <fsc_runtime.h>
#include <wrapper_helper.h>

#include <sys/stat.h>

#if 0

/**
 * @fn int chmod(const char *path, mode_t mode);
 * @brief change file mode.
 * @param path path of file.
 * @param mode bit or of file permission bits.
 * @retval 0 success.
 * @retval -1 error occured. mode not changed.
 *
 * @crashcase illegal pointer, non-terminated string
 * @fsctype string(ro)
 *
 * @author Lepidum Co., Ltd.
 */
value FS_FPci_i_chmod(base_t path_b, ofs_t path_o,
                      base_t mode_b, ofs_t mode_o
                      )
{
  int ret;
  void *tmp;
  char *path = wrapper_get_string_z(path_b, path_o, &tmp, "chmod");

  ret = chmod(path, mode_o);

  wrapper_release_tmpbuf(tmp);
  return value_of_int(ret);
}

#endif
