/* 
   Part of Fail-Safe C Runtime. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2006 AIST.
   (c) 2006	 Lepidum Co. Ltd.

   This file is written by Yutaka Oiwa and Lepidum Co. Ltd. in 2004-2006.

   This file is distributed under Apache License 2.0 with a special exception.
   See the file LICENSE contained in the distribution.
*/
/**
 * @file stdlib/time.c
 */
#define FSC_RUNTIME_LIBRARY
#include <fsc_runtime.h>
#include <wrapper_helper.h>
#include <copydata.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <sys/utsname.h>
#include <string.h>

#include "uname_storage.safe.c"


#define UNAME_ELEMSIZE 1024

/**
 * @fn int uname(struct utsname*name)
 * @author Yutaka Oiwa.
 */
value FS_FPSn14stdlib_utsname__i_uname(base_t base0, ofs_t ofs) {
    struct utsname buf;
    int r;

    if (base_remove_castflag(base0) == 0) {
        r = uname(0);
        return value_of_int(r);
    }
    r = uname(&buf);

    if (r == 0) {
	fsc_copy_from_raw(base0, ofs, buf.sysname, strlen(buf.sysname) + 1);
	fsc_copy_from_raw(base0, ofs + UNAME_ELEMSIZE, buf.nodename, strlen(buf.nodename) + 1);
	fsc_copy_from_raw(base0, ofs + UNAME_ELEMSIZE * 2, buf.release, strlen(buf.release) + 1);
	fsc_copy_from_raw(base0, ofs + UNAME_ELEMSIZE * 3, buf.version, strlen(buf.version) + 1);
	fsc_copy_from_raw(base0, ofs + UNAME_ELEMSIZE * 4, buf.machine, strlen(buf.machine) + 1);
    }
    return value_of_int(r);
}
