#include "common.h"
#include <stdio.h>

static double d[] = {
    0.0, /* 0 */
    -0.0,
    (1.0 / 0.0),
    (0.0 / 0.0),
    (0.0 / 0.0 / 0.0),
    (-1.0 / 0.0),
    0, 
    (1.0 / 0.0),
    1e-100,
    1e-50,
    1e-10, /* 10 */
    1e-9,
    1e-8,
    1e-7,
    1e-6,
    1e-5,
    1e-4,
    1e-3,
    1e-2,
    1e-1,
    0.125, /* 20 */
    0.25,
    0.5,
    2.0 / 3,
    1.0,
    1.1,
    1.2,
    1.3,
    1.4,
    1.5,
    2, /* 30 */
    4,
    8,
    1e+10,
    1e+20,
    1234567890123456789012345.,
    1234567890123456789012345, /* truncated because of integer overflow */
    1e+30,
    1e+40,
    1e+100 /* 39 */
};

static int r[] = {
    /* 4:< 2:= 1:>   ...  NC:0 >:1 =:2 <:4 */
    2, 4, 0, 0, 0, 4, 4, 1, 4, 4, 
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
    4, 4, 4, 4, 4, 1, 4, 4, 4
};

int __static_assert[((sizeof d / sizeof d[0]) - 1 == (sizeof r / sizeof r[0]))] = {1};

TEST_CASE(baseline_18_floating)
{
    int i, j;

    for(i = 0; i < 39; i++) {
	j = 0;
	if (d[i] > d[i + 1]) j |= 1;
	if (d[i] == d[i + 1]) j |= 2;
	if (d[i] < d[i + 1]) j |= 4;
	
	/*	fprintf(stderr, "%20g %c %20g [%c]\n", d[i], "!>=?<???"[j], d[i + 1], "!>=?<???"[r[i]]); */
	TEST(j == r[i]);
    }
    TEST(1);
}
