(* 
   Part of Fail-Safe C Compiler. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2008 AIST.

   This file is written by Yutaka Oiwa in 2008. *)

(** Pretty printer for IL types. *)

val pp_list :
  (Format.formatter -> 'a -> unit) ->
  string -> Format.formatter -> 'a list -> unit

val pp_ctt_type : Format.formatter -> Ctt_abstree.c_type -> unit

val pp_temp_id : Format.formatter -> int -> unit
val pp_identifier : Format.formatter -> string -> unit
val pp_field : Format.formatter -> string * Ctt_abstree.c_type -> unit
val pp_il_switch_label : Format.formatter -> Il.il_switch_label -> unit
val pp_il_if_type : Format.formatter -> Il.il_if_type -> unit
val pp_il_binop : Format.formatter -> Il.il_binop -> unit
val pp_il_lvalue : Format.formatter -> Il.il_lvalue -> unit
val pp_il_expr : Format.formatter -> Il.il_expr -> unit
val pp_il_initalizer : Format.formatter -> 'a -> unit
val pp_il : Format.formatter -> Il.il -> unit
val pp_il_basic_block_base :
  (Format.formatter -> 'a -> unit) ->
  int -> Format.formatter -> 'a Il.il_basic_block_base -> unit
val pp_il_basic_block :
  int -> Format.formatter -> Il.il Il.il_basic_block_base -> unit
val pp_il_function_base :
  (Format.formatter -> 'a -> unit) ->
  'b -> Format.formatter -> ('a, 'c) Il.il_function_base -> unit
val pp_il_function :
  'a -> Format.formatter -> (Il.il, 'b) Il.il_function_base -> unit
val pp_il_global_declaration_base :
  (Format.formatter -> 'a -> unit) ->
  'b ->
  (Format.formatter -> 'c -> unit) ->
  Format.formatter -> ('a, 'd, 'c) Il.il_global_declaration_base -> unit
val pp_il_global_declaration :
  'a ->
  'b ->
  Format.formatter -> (Il.il, 'c, 'd) Il.il_global_declaration_base -> unit
